Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/vdif_kcay.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/vdif_kcay.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/vdif_kcay.F90	(revision 4727)
@@ -2,7 +2,7 @@
 ! $Header$
 
-SUBROUTINE vdif_kcay(ngrid, dt, g, rconst, plev, temp, zlev, zlay, u, v, &
+SUBROUTINE vdif_kcay(klon,klev,ngrid,dt, g, rconst, plev, temp, zlev, zlay, u, v, &
     teta, cd, q2, q2diag, km, kn, ustar, l_mix)
-  USE dimphy
+
   IMPLICIT NONE
 
@@ -28,20 +28,26 @@
 
   ! .......................................................................
-  REAL dt, g, rconst
-  REAL plev(klon, klev+1), temp(klon, klev)
-  REAL ustar(klon), snstable
-  REAL zlev(klon, klev+1)
-  REAL zlay(klon, klev)
-  REAL u(klon, klev)
-  REAL v(klon, klev)
-  REAL teta(klon, klev)
-  REAL cd(klon)
-  REAL q2(klon, klev+1), q2s(klon, klev+1)
-  REAL q2diag(klon, klev+1)
-  REAL km(klon, klev+1)
-  REAL kn(klon, klev+1)
-  REAL sq(klon), sqz(klon), zz(klon, klev+1), zq, long0(klon)
-
-  INTEGER l_mix, iii
+  INTEGER, INTENT(IN) :: klon,klev,ngrid
+  REAL,INTENT(IN) :: dt, g, rconst
+  REAL,DIMENSION(klon,klev+1),INTENT(IN) :: plev
+  REAL,DIMENSION(klon,klev),INTENT(IN) :: temp
+  REAL,DIMENSION(klon),INTENT(IN) :: ustar
+  REAL,DIMENSION(klon,klev+1),INTENT(INOUT) :: zlev
+  REAL,DIMENSION(klon,klev),INTENT(IN) :: zlay
+  REAL,DIMENSION(klon,klev),INTENT(IN) :: u
+  REAL,DIMENSION(klon,klev),INTENT(IN) :: v
+  REAL,DIMENSION(klon,klev),INTENT(IN) :: teta
+  REAL,DIMENSION(klon),INTENT(IN) :: cd
+  REAL,DIMENSION(klon,klev+1),INTENT(INOUT) :: q2
+  REAL,DIMENSION(klon,klev+1),INTENT(OUT) :: q2diag
+  REAL,DIMENSION(klon,klev+1),INTENT(OUT) :: km
+  REAL,DIMENSION(klon,klev+1),INTENT(OUT) :: kn
+  INTEGER, INTENT(OUT) :: l_mix
+
+  REAL,DIMENSION(klon) :: sq, sqz, long0
+  REAL,DIMENSION(klon,klev+1) :: q2s,zz
+  REAL :: snstable,zq
+
+  INTEGER :: iii
   ! .......................................................................
 
@@ -56,8 +62,7 @@
 
   ! .......................................................................
-  INTEGER nlay, nlev, ngrid
-  REAL unsdz(klon, klev)
-  REAL unsdzdec(klon, klev+1)
-  REAL q(klon, klev+1)
+  INTEGER :: nlay, nlev
+  REAL, DIMENSION(klon,klev) :: unsdz
+  REAL, DIMENSION(klon, klev+1) :: unsdzdec,q
 
   ! .......................................................................
@@ -70,8 +75,8 @@
 
   ! .......................................................................
-  REAL kmpre(klon, klev+1)
-  REAL qcstat
-  REAL q2cstat
-  REAL sss, sssq
+  REAL, DIMENSION(klon, klev+1) :: kmpre
+  REAL :: qcstat
+  REAL :: q2cstat
+  REAL :: sss, sssq
   ! .......................................................................
 
@@ -79,5 +84,5 @@
 
   ! .......................................................................
-  REAL long(klon, klev+1)
+  REAL, DIMENSION(klon, klev+1) :: long
   ! .......................................................................
 
@@ -97,13 +102,10 @@
 
   ! .......................................................................
-  REAL kmq3
-  REAL kmcstat
-  REAL knq3
-  REAL mcstat
-  REAL m2cstat
-  REAL m(klon, klev+1)
-  REAL mpre(klon, klev+1)
-  REAL m2(klon, klev+1)
-  REAL n2(klon, klev+1)
+  REAL :: kmq3
+  REAL :: kmcstat
+  REAL :: knq3
+  REAL :: mcstat
+  REAL :: m2cstat
+  REAL, DIMENSION(klon, klev+1) :: m,mpre,m2,n2
   ! .......................................................................
 
@@ -121,15 +123,10 @@
 
   ! .......................................................................
-  REAL gn
-  REAL gnmin
-  REAL gnmax
-  LOGICAL gninf
-  LOGICAL gnsup
-  REAL gm
-  ! REAL ri(klon,klev+1)
-  REAL sn(klon, klev+1)
-  REAL snq2(klon, klev+1)
-  REAL sm(klon, klev+1)
-  REAL smq2(klon, klev+1)
+  REAL :: gn,gm
+  REAL :: gnmin
+  REAL :: gnmax
+  LOGICAL :: gninf
+  LOGICAL :: gnsup
+  REAL, DIMENSION(klon, klev+1) :: sn, snq2, sm, smq2
   ! .......................................................................
 
@@ -142,9 +139,9 @@
 
   ! .......................................................................
-  REAL kappa
-  REAL long00
-  REAL a1, a2, b1, b2, c1
-  REAL cn1, cn2
-  REAL cm1, cm2, cm3, cm4
+  REAL :: kappa
+  REAL :: long00
+  REAL :: a1, a2, b1, b2, c1
+  REAL :: cn1, cn2
+  REAL :: cm1, cm2, cm3, cm4
   ! .......................................................................
 
@@ -155,8 +152,8 @@
 
   ! .......................................................................
-  REAL termq
-  REAL termq3
-  REAL termqm2
-  REAL termq3m2
+  REAL :: termq
+  REAL :: termq3
+  REAL :: termqm2
+  REAL :: termq3m2
   ! .......................................................................
 
@@ -165,15 +162,15 @@
 
   ! .......................................................................
-  REAL q2min
-  REAL q2max
+  REAL :: q2min
+  REAL :: q2max
   ! .......................................................................
   ! knmin : borne inferieure de kn
   ! kmmin : borne inferieure de km
   ! .......................................................................
-  REAL knmin
-  REAL kmmin
-  ! .......................................................................
-  INTEGER ilay, ilev, igrid
-  REAL tmp1, tmp2
+  REAL :: knmin
+  REAL :: kmmin
+  ! .......................................................................
+  INTEGER :: ilay, ilev, igrid
+  REAL :: tmp1, tmp2
   ! .......................................................................
   PARAMETER (kappa=0.4E+0)
@@ -202,8 +199,8 @@
   PARAMETER (cm4=-9.E+0*a1*a2)
 
-  LOGICAL first
-  SAVE first
-  DATA first/.TRUE./
-  !$OMP THREADPRIVATE(first)
+  LOGICAL :: first
+!  SAVE first
+!  DATA first/.TRUE./
+!  !$OMP THREADPRIVATE(first)
   ! .......................................................................
   ! traitment des valeur de q2 en entree
@@ -214,12 +211,14 @@
   nlev = klev + 1
 
-  CALL yamada(ngrid, dt, g, rconst, plev, temp, zlev, zlay, u, v, teta, cd, &
-    q2diag, km, kn, ustar, l_mix)
-  IF (first .AND. 1==1) THEN
-    first = .FALSE.
-    q2 = q2diag
-  END IF
-
-  DO ilev = 1, nlev
+! Initialisation avec un schema d'equilibre
+! CALL yamada(ngrid, dt, g, rconst, plev, temp, zlev, zlay, u, v, teta, cd, &
+!   q2diag, km, kn, ustar, l_mix)
+! IF (first .AND. 1==1) THEN
+!   first = .FALSE.
+!   q2 = q2diag
+! END IF
+q2diag=0.
+
+  DO ilev = 2, nlay
     DO igrid = 1, ngrid
       q2(igrid, ilev) = amax1(q2(igrid,ilev), q2min)
@@ -360,6 +359,4 @@
       gninf = .FALSE.
       gnsup = .FALSE.
-      long(igrid, ilev) = long(igrid, ilev)
-      long(igrid, ilev) = long(igrid, ilev)
 
       IF (gn<gnmin) THEN
@@ -591,4 +588,7 @@
   IF (1==1) THEN
 
+    sss=0.
+    sssq=0.
+    ! WARNING : travail sur le point ig=1 ????
     DO ilev = 2, klev - 1
       sss = sss + plev(1, ilev-1) - plev(1, ilev+1)
@@ -624,5 +624,5 @@
 
 
-    DO ilev = 1, nlev
+    DO ilev = 2, klev-1
       DO igrid = 1, ngrid
         q2(igrid, ilev) = max(q2(igrid,ilev), q2min)
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/yamada.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/yamada.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/yamada.F90	(revision 4727)
@@ -128,5 +128,5 @@
     l0(ig) = 100.
   END DO
-  DO k = 2, klev - 1
+  DO k = 2, klev
     DO ig = 1, ngrid
       l(ig, k) = l0(ig)*kap*zlev(ig, k)/(kap*zlev(ig,k)+l0(ig))
@@ -139,5 +139,6 @@
       sqz(ig) = 1.E-10
     END DO
-    DO k = 2, klev - 1
+    !DO k = 2, klev - 1
+    DO k = 2, klev
       DO ig = 1, ngrid
         q2(ig, k) = l(ig, k)**2*zz(ig, k)
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/yamada_c.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/yamada_c.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/yamada_c.F90	(revision 4727)
@@ -10,5 +10,5 @@
 
       IMPLICIT NONE
-#include "YOMCST.h"
+      INCLUDE "YOMCST.h"
 !
 ! timestep : pas de temps
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/StratAer
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/StratAer	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/StratAer	(revision 4727)
@@ -1,1 +1,1 @@
-link ../phylmd/StratAer/
+link ../phylmd/StratAer
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/add_phys_tend_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/add_phys_tend_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/add_phys_tend_mod.F90	(revision 4727)
@@ -16,5 +16,5 @@
 CONTAINS
 
-SUBROUTINE add_pbl_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text,abortphy,flag_inhib_tend, itap &
+SUBROUTINE add_pbl_tend(zdu, zdv, zdt, zdq, zdql, zdqi, zdqbs, paprs, text,abortphy,flag_inhib_tend, itap &
 #ifdef ISO
         ,zdxt,zdxtl,zdxti &
@@ -62,5 +62,5 @@
   ! ------------
   REAL zdu(klon, klev), zdv(klon, klev)
-  REAL zdt(klon, klev), zdq(klon, klev), zdql(klon, klev), zdqi(klon, klev)
+  REAL zdt(klon, klev), zdq(klon, klev), zdql(klon, klev), zdqi(klon, klev), zdqbs(klon,klev)
   CHARACTER *(*) text
   REAL paprs(klon,klev+1)
@@ -104,5 +104,5 @@
     PRINT *, ' add_pbl_tend, zzdt ', zzdt
     PRINT *, ' add_pbl_tend, zzdq ', zzdq
-    CALL add_phys_tend(zdu, zdv, zzdt, zzdq, zdql, zdqi, paprs, text,abortphy,flag_inhib_tend, itap, 0 &
+    CALL add_phys_tend(zdu, zdv, zzdt, zzdq, zdql, zdqi, zdqbs, paprs, text,abortphy,flag_inhib_tend, itap, 0 &
 #ifdef ISO
         ,zzdxt,zdxtl,zdxti &
@@ -110,5 +110,5 @@
         )
   ELSE
-    CALL add_phys_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text,abortphy,flag_inhib_tend, itap, 0 &
+    CALL add_phys_tend(zdu, zdv, zdt, zdq, zdql, zdqi, zdqbs, paprs, text,abortphy,flag_inhib_tend, itap, 0 &
 #ifdef ISO
         ,zdxt,zdxtl,zdxti &
@@ -123,5 +123,5 @@
 ! $Id$
 !
-SUBROUTINE add_phys_tend (zdu,zdv,zdt,zdq,zdql,zdqi,paprs,text, &
+SUBROUTINE add_phys_tend (zdu,zdv,zdt,zdq,zdql,zdqi,zdqbs,paprs,text, &
                           abortphy,flag_inhib_tend, itap, diag_mode &
 #ifdef ISO
@@ -142,5 +142,5 @@
 USE dimphy, ONLY: klon, klev
 USE phys_state_var_mod, ONLY : phys_tstep
-USE phys_local_var_mod, ONLY: u_seri, v_seri, ql_seri, qs_seri, q_seri, t_seri
+USE phys_local_var_mod, ONLY: u_seri, v_seri, ql_seri, qs_seri, qbs_seri, q_seri, t_seri
 #ifdef ISO
 USE phys_local_var_mod, ONLY: xtl_seri, xts_seri, xt_seri
@@ -150,6 +150,6 @@
 USE print_control_mod, ONLY: prt_level
 USE cmp_seri_mod
-USE phys_output_var_mod, ONLY : d_qw_col, d_ql_col, d_qs_col, d_qt_col, d_ek_col, d_h_dair_col &
-  &           , d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_col
+USE phys_output_var_mod, ONLY : d_qw_col, d_ql_col, d_qs_col, d_qbs_col, d_qt_col, d_ek_col, d_h_dair_col &
+  &           , d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_qbs_col, d_h_col
 
 #ifdef ISO
@@ -167,5 +167,5 @@
 !------------
 REAL, DIMENSION(klon,klev),     INTENT(IN)    :: zdu, zdv
-REAL, DIMENSION(klon,klev),     INTENT(IN)    :: zdt, zdql, zdqi
+REAL, DIMENSION(klon,klev),     INTENT(IN)    :: zdt, zdql, zdqi, zdqbs
 REAL, DIMENSION(klon,klev+1),   INTENT(IN)    :: paprs
 CHARACTER*(*),                  INTENT(IN)    :: text
@@ -197,5 +197,5 @@
 ! Save variables, used in diagnostic mode (diag_mode=1).
 REAL, DIMENSION(klon,klev)   :: sav_u_seri, sav_v_seri
-REAL, DIMENSION(klon,klev)   :: sav_ql_seri, sav_qs_seri, sav_q_seri
+REAL, DIMENSION(klon,klev)   :: sav_ql_seri, sav_qs_seri, sav_qbs_seri, sav_q_seri
 REAL, DIMENSION(klon,klev)   :: sav_t_seri
 REAL, DIMENSION(klon,klev)   :: sav_zdq
@@ -228,7 +228,9 @@
 ! zh_ql_col----  total enthalpy of liquid watter (J/m2)
 ! zh_qs_col----  total enthalpy of solid watter  (J/m2)
+! zh_qbs_col----  total enthalpy of blowing snow  (J/m2)
 ! zqw_col------  total mass of watter vapour (kg/m2)
 ! zql_col------  total mass of liquid watter (kg/m2)
-! zqs_col------  total mass of solid watter (kg/m2)
+! zqs_col------  total mass of cloud ice (kg/m2)
+! zqbs_col------  total mass of blowing snow (kg/m2)
 ! zek_col------  total kinetic energy (kg/m2)
 !
@@ -237,7 +239,8 @@
 REAL zql_col(klon,2)
 REAL zqs_col(klon,2)
+REAL zqbs_col(klon,2)
 REAL zek_col(klon,2)
 REAL zh_dair_col(klon,2)
-REAL zh_qw_col(klon,2), zh_ql_col(klon,2), zh_qs_col(klon,2)
+REAL zh_qw_col(klon,2), zh_ql_col(klon,2), zh_qs_col(klon,2), zh_qbs_col(klon,2)
 REAL zh_col(klon,2)
 
@@ -278,4 +281,5 @@
     sav_ql_seri(:,:) = ql_seri(:,:)
     sav_qs_seri(:,:) = qs_seri(:,:)
+    sav_qbs_seri(:,:) = qbs_seri(:,:)
     sav_q_seri(:,:)  = q_seri(:,:)
     sav_t_seri(:,:)  = t_seri(:,:)
@@ -304,7 +308,7 @@
 
     CALL integr_v(klon, klev, zcpvap, &
-                  t_seri, q_seri, ql_seri, qs_seri, u_seri, v_seri, zairm, &
-                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
-                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_col(:,n))
+                  t_seri, q_seri, ql_seri, qs_seri, qbs_seri, u_seri, v_seri, zairm, &
+                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zqbs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
+                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_qbs_col(:,n), zh_col(:,n))
 
   end if ! end if (fl_ebil .GT. 0)
@@ -313,4 +317,23 @@
 ! Ajout des tendances sur le vent et l'eau liquide
 !======================================================================
+
+#ifdef ISO
+#ifdef ISOVERIF
+        if (iso_eau.gt.0) then
+          call iso_verif_egalite_vect2D( &
+                xt_seri,q_seri, &
+                'add_phys_tend 321a: '//text,ntraciso,klon,klev)
+          call iso_verif_egalite_vect2D( &
+                xtl_seri,ql_seri, &
+                'add_phys_tend 321b: '//text,ntraciso,klon,klev)
+         endif !if (iso_eau.gt.0) then
+#ifdef ISOTRAC
+        call iso_verif_traceur_vect(xt_seri,klon,klev, &
+     &           'add_phys_tend 328a: '//text)
+        call iso_verif_traceur_vect(xtl_seri,klon,klev, &
+     &           'add_phys_tend 328b: '//text)
+#endif
+#endif
+#endif
 
      u_seri(:,:)=u_seri(:,:)+zdu(:,:)
@@ -318,4 +341,5 @@
      ql_seri(:,:)=ql_seri(:,:)+zdql(:,:)
      qs_seri(:,:)=qs_seri(:,:)+zdqi(:,:)
+     qbs_seri(:,:)=qbs_seri(:,:)+zdqbs(:,:)
 #ifdef ISO 
      xtl_seri(:,:,:)=xtl_seri(:,:,:)+zdxtl(:,:,:) 
@@ -370,4 +394,10 @@
                 'add_phys_tend 138: '//text,ntraciso,klon,klev)
          endif !if (iso_eau.gt.0) then
+#ifdef ISOTRAC
+        call iso_verif_traceur_vect(xt_seri,klon,klev, &
+     &           'add_phys_tend 374a: '//text)
+        call iso_verif_traceur_vect(xtl_seri,klon,klev, &
+     &           'add_phys_tend 374b: '//text)
+#endif
 #endif
 #endif
@@ -495,4 +525,8 @@
                         'add_phys_tend 175'//text,ntraciso,klon,klev)
       endif !if (iso_eau.gt.0) then
+#ifdef ISOTRAC
+        call iso_verif_traceur_vect(xt_seri,klon,klev, &
+     &           'add_phys_tend 499'//text)
+#endif
 #endif
 #endif
@@ -572,4 +606,5 @@
         ql_seri(:,:)=ql_seri(:,:)-zdql(:,:)
         qs_seri(:,:)=qs_seri(:,:)-zdqi(:,:)
+        qbs_seri(:,:)=qbs_seri(:,:)-zdqbs(:,:)
       ENDIF
 
@@ -586,7 +621,7 @@
 
     CALL integr_v(klon, klev, zcpvap, &
-                  t_seri, q_seri, ql_seri, qs_seri, u_seri, v_seri, zairm, &
-                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
-                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_col(:,n))
+                  t_seri, q_seri, ql_seri, qs_seri, qbs_seri, u_seri, v_seri, zairm, &
+                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zqbs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
+                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_qbs_col(:,n), zh_col(:,n))
 
     ! ------------------------------------------------
@@ -597,5 +632,6 @@
     d_ql_col(:) = (zql_col(:,2)-zql_col(:,1))/phys_tstep
     d_qs_col(:) = (zqs_col(:,2)-zqs_col(:,1))/phys_tstep
-    d_qt_col(:) = d_qw_col(:) + d_ql_col(:) + d_qs_col(:)
+    d_qbs_col(:) = (zqbs_col(:,2)-zqbs_col(:,1))/phys_tstep
+    d_qt_col(:) = d_qw_col(:) + d_ql_col(:) + d_qs_col(:) + d_qbs_col(:)
 
     d_ek_col(:) = (zek_col(:,2)-zek_col(:,1))/phys_tstep
@@ -605,4 +641,5 @@
     d_h_ql_col(:) = (zh_ql_col(:,2)-zh_ql_col(:,1))/phys_tstep
     d_h_qs_col(:) = (zh_qs_col(:,2)-zh_qs_col(:,1))/phys_tstep
+    d_h_qbs_col(:) = (zh_qbs_col(:,2)-zh_qbs_col(:,1))/phys_tstep
 
     d_h_col = (zh_col(:,2)-zh_col(:,1))/phys_tstep 
@@ -616,4 +653,5 @@
     ql_seri(:,:) = sav_ql_seri(:,:)
     qs_seri(:,:) = sav_qs_seri(:,:)
+    qbs_seri(:,:) = sav_qbs_seri(:,:)
     q_seri(:,:)  = sav_q_seri(:,:)
     t_seri(:,:)  = sav_t_seri(:,:)
@@ -630,6 +668,6 @@
 END SUBROUTINE add_phys_tend
 
-SUBROUTINE diag_phys_tend (nlon, nlev, uu, vv, temp, qv, ql, qs, &
-                          zdu,zdv,zdt,zdq,zdql,zdqs,paprs,text)
+SUBROUTINE diag_phys_tend (nlon, nlev, uu, vv, temp, qv, ql, qs, qbs, &
+                          zdu,zdv,zdt,zdq,zdql,zdqs,zdqbs,paprs,text)
 !======================================================================
 ! Ajoute les tendances des variables physiques aux variables 
@@ -647,6 +685,6 @@
 USE print_control_mod, ONLY: prt_level
 USE cmp_seri_mod
-USE phys_output_var_mod, ONLY : d_qw_col, d_ql_col, d_qs_col, d_qt_col, d_ek_col, d_h_dair_col &
-  &           , d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_col
+USE phys_output_var_mod, ONLY : d_qw_col, d_ql_col, d_qs_col, d_qbs_col, d_qt_col, d_ek_col, d_h_dair_col &
+  &           , d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_qbs_col, d_h_col
 IMPLICIT none
   include "YOMCST.h"
@@ -657,7 +695,7 @@
 INTEGER, INTENT(IN)                           :: nlon, nlev
 REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: uu, vv
-REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: temp, qv, ql, qs
+REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: temp, qv, ql, qs, qbs
 REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: zdu, zdv
-REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: zdt, zdq, zdql, zdqs
+REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: zdt, zdq, zdql, zdqs, zdqbs
 REAL, DIMENSION(nlon,nlev+1),   INTENT(IN)    :: paprs
 CHARACTER*(*),                  INTENT(IN)    :: text
@@ -666,5 +704,5 @@
 !--------
 REAL, DIMENSION(nlon,nlev)      :: uu_n, vv_n
-REAL, DIMENSION(nlon,nlev)      :: temp_n, qv_n, ql_n, qs_n
+REAL, DIMENSION(nlon,nlev)      :: temp_n, qv_n, ql_n, qs_n, qbs_n
 
 
@@ -689,5 +727,6 @@
 ! zqw_col------  total mass of watter vapour (kg/m2)
 ! zql_col------  total mass of liquid watter (kg/m2)
-! zqs_col------  total mass of solid watter (kg/m2)
+! zqs_col------  total mass of cloud ice (kg/m2)
+! zqbs_col------  total mass of blowing snow (kg/m2)
 ! zek_col------  total kinetic energy (kg/m2)
 !
@@ -696,7 +735,8 @@
 REAL zql_col(nlon,2)
 REAL zqs_col(nlon,2)
+REAL zqbs_col(nlon,2)
 REAL zek_col(nlon,2)
 REAL zh_dair_col(nlon,2)
-REAL zh_qw_col(nlon,2), zh_ql_col(nlon,2), zh_qs_col(nlon,2)
+REAL zh_qw_col(nlon,2), zh_ql_col(nlon,2), zh_qs_col(nlon,2), zh_qbs_col(nlon,2)
 REAL zh_col(nlon,2)
 
@@ -731,7 +771,7 @@
 
     CALL integr_v(nlon, nlev, rcpv, &
-                  temp, qv, ql, qs, uu, vv, zairm, &
-                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
-                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_col(:,n))
+                  temp, qv, ql, qs, qbs, uu, vv, zairm, &
+                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zqbs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
+                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_qbs_col(:,n), zh_col(:,n))
 
   end if ! end if (fl_ebil .GT. 0)
@@ -746,4 +786,5 @@
      ql_n(:,:)=ql(:,:)+zdql(:,:)
      qs_n(:,:)=qs(:,:)+zdqs(:,:)
+     qbs_n(:,:)=qbs(:,:)+zdqbs(:,:)
      temp_n(:,:)=temp(:,:)+zdt(:,:)
 
@@ -762,7 +803,7 @@
 
     CALL integr_v(nlon, nlev, rcpv, &
-                  temp_n, qv_n, ql_n, qs_n, uu_n, vv_n, zairm, &
-                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
-                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_col(:,n))
+                  temp_n, qv_n, ql_n, qs_n, qbs_n, uu_n, vv_n, zairm, &
+                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zqbs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
+                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_qbs_col(:,n), zh_col(:,n))
 
     ! ------------------------------------------------
@@ -773,5 +814,6 @@
     d_ql_col(:) = (zql_col(:,2)-zql_col(:,1))/phys_tstep
     d_qs_col(:) = (zqs_col(:,2)-zqs_col(:,1))/phys_tstep
-    d_qt_col(:) = d_qw_col(:) + d_ql_col(:) + d_qs_col(:)
+    d_qbs_col(:) = (zqbs_col(:,2)-zqbs_col(:,1))/phys_tstep
+    d_qt_col(:) = d_qw_col(:) + d_ql_col(:) + d_qs_col(:) + d_qbs_col(:)
 
     d_ek_col(:) = (zek_col(:,2)-zek_col(:,1))/phys_tstep
@@ -785,4 +827,5 @@
     d_h_ql_col(:) = (zh_ql_col(:,2)-zh_ql_col(:,1))/phys_tstep
     d_h_qs_col(:) = (zh_qs_col(:,2)-zh_qs_col(:,1))/phys_tstep
+    d_h_qbs_col(:) = (zh_qbs_col(:,2)-zh_qbs_col(:,1))/phys_tstep
 
     d_h_col = (zh_col(:,2)-zh_col(:,1))/phys_tstep 
@@ -795,7 +838,7 @@
 
 SUBROUTINE integr_v(nlon, nlev, zcpvap, &
-                    temp, qv, ql, qs, uu, vv, zairm,  &
-                    zqw_col, zql_col, zqs_col, zek_col, zh_dair_col, &
-                    zh_qw_col, zh_ql_col, zh_qs_col, zh_col)
+                    temp, qv, ql, qs, qbs, uu, vv, zairm,  &
+                    zqw_col, zql_col, zqs_col, zqbs_col, zek_col, zh_dair_col, &
+                    zh_qw_col, zh_ql_col, zh_qs_col, zh_qbs_col, zh_col)
 
 IMPLICIT none
@@ -804,14 +847,14 @@
 INTEGER,                    INTENT(IN)    :: nlon,nlev
 REAL,                       INTENT(IN)    :: zcpvap
-REAL, DIMENSION(nlon,nlev), INTENT(IN)    :: temp, qv, ql, qs, uu, vv
+REAL, DIMENSION(nlon,nlev), INTENT(IN)    :: temp, qv, ql, qs, qbs, uu, vv
 REAL, DIMENSION(nlon,nlev), INTENT(IN)    :: zairm
 REAL, DIMENSION(nlon),      INTENT(OUT)   :: zqw_col
 REAL, DIMENSION(nlon),      INTENT(OUT)   :: zql_col
-REAL, DIMENSION(nlon),      INTENT(OUT)   :: zqs_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zqs_col, zqbs_col
 REAL, DIMENSION(nlon),      INTENT(OUT)   :: zek_col
 REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_dair_col
 REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_qw_col
 REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_ql_col
-REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_qs_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_qs_col, zh_qbs_col
 REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_col
 
@@ -823,4 +866,5 @@
     zql_col(:) = 0.
     zqs_col(:) = 0.
+    zqbs_col(:) = 0.
     zek_col(:) = 0.
     zh_dair_col(:) = 0.
@@ -828,4 +872,5 @@
     zh_ql_col(:) = 0.
     zh_qs_col(:) = 0.
+    zh_qbs_col(:) = 0.
 
 !JLD    write (*,*) "rcpd, zcpvap, zcwat, zcice ",rcpd, zcpvap, zcwat, zcice
@@ -840,4 +885,5 @@
         zql_col(i) = zql_col(i) + ql(i, k)*zairm(i, k)
         zqs_col(i) = zqs_col(i) + qs(i, k)*zairm(i, k)
+        zqbs_col(i)= zqbs_col(i) + qbs(i,k)*zairm(i,k)
         ! Kinetic Energy
         zek_col(i) = zek_col(i) + 0.5*(uu(i,k)**2+vv(i,k)**2)*zairm(i, k)
@@ -848,8 +894,9 @@
         zh_ql_col(i) = zh_ql_col(i) + (zcpvap*temp(i, k) - rlvtt)*ql(i, k)*zairm(i, k)   !jyg
         zh_qs_col(i) = zh_qs_col(i) + (zcpvap*temp(i, k) - rlstt)*qs(i, k)*zairm(i, k)   !jyg
+        zh_qbs_col(i) = zh_qbs_col(i) + (zcpvap*temp(i, k) - rlstt)*qbs(i, k)*zairm(i, k)   !jyg
       END DO
     END DO
     ! compute total air enthalpy
-    zh_col(:) = zh_dair_col(:) + zh_qw_col(:) + zh_ql_col(:) + zh_qs_col(:)
+    zh_col(:) = zh_dair_col(:) + zh_qw_col(:) + zh_ql_col(:) + zh_qs_col(:) + zh_qbs_col(:)
 
 END SUBROUTINE integr_v
@@ -866,12 +913,12 @@
 USE dimphy, ONLY: klon, klev
 USE phys_state_var_mod, ONLY : phys_tstep
-USE phys_state_var_mod, ONLY : topsw, toplw, solsw, sollw, rain_con, snow_con
+USE phys_state_var_mod, ONLY : topsw, toplw, solsw, sollw, rain_con, snow_con, bs_fall
 USE geometry_mod, ONLY: longitude_deg, latitude_deg
 USE print_control_mod, ONLY: prt_level
 USE cmp_seri_mod
-USE phys_output_var_mod, ONLY : d_qw_col, d_ql_col, d_qs_col, d_qt_col, d_ek_col, d_h_dair_col &
-  &           , d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_col
+USE phys_output_var_mod, ONLY : d_qw_col, d_ql_col, d_qs_col, d_qbs_col, d_qt_col, d_ek_col, d_h_dair_col &
+  &           , d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_qbs_col, d_h_col
 USE phys_local_var_mod, ONLY: evap, sens
-USE phys_local_var_mod, ONLY: u_seri, v_seri, ql_seri, qs_seri, q_seri, t_seri &
+USE phys_local_var_mod, ONLY: u_seri, v_seri, ql_seri, qs_seri, qbs_seri, q_seri, t_seri &
    &  , rain_lsc, snow_lsc
 USE climb_hq_mod, ONLY : d_h_col_vdf, f_h_bnd
@@ -910,4 +957,7 @@
       bilh_bnd = (-(rcw-rcpd)*t_seri(1,1) + rlvtt) * rain_lsc(1) &
     &         + (-(rcs-rcpd)*t_seri(1,1) + rlstt) * snow_lsc(1)
+  CASE("bs") param
+      bilq_bnd = - bs_fall(1)
+      bilh_bnd = (-(rcs-rcpd)*t_seri(1,1) + rlstt) * bs_fall(1)
   CASE("convection") param
       bilq_bnd = - rain_con(1) - snow_con(1)
@@ -946,6 +996,6 @@
   if ( prt_level .GE. 5) then
     write(*,9000) text,"enerbil at boundaries: Q, H",bilq_bnd, bilh_bnd
-    write(*,9000) text,"enerbil: water budget",d_qt_col(1),d_qw_col(1),d_ql_col(1),d_qs_col(1)
-    write(*,9000) text,"enerbil: enthalpy budget",d_h_col(1),d_h_dair_col(1),d_h_qw_col(1),d_h_ql_col(1),d_h_qs_col(1)
+    write(*,9000) text,"enerbil: water budget",d_qt_col(1),d_qw_col(1),d_ql_col(1),d_qs_col(1), d_qbs_col(1)
+    write(*,9000) text,"enerbil: enthalpy budget",d_h_col(1),d_h_dair_col(1),d_h_qw_col(1),d_h_ql_col(1),d_h_qs_col(1),d_h_qbs_col(1)
   end if
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/calwake.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/calwake.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/calwake.F90	(revision 4727)
@@ -39,4 +39,6 @@
   USE isotopes_mod, ONLY: iso_eau
   USE isotopes_verif_mod
+  USE lmdz_wake, ONLY : wake
+
 #endif
 #endif
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/chemistry_cycle_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/chemistry_cycle_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/chemistry_cycle_mod.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/chemistry_cycle_mod.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/clc_core_cp.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/clc_core_cp.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/clc_core_cp.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/clc_core_cp.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/climb_qbs_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/climb_qbs_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/climb_qbs_mod.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/climb_qbs_mod.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/coare30_flux_cnrm.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/coare30_flux_cnrm.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/coare30_flux_cnrm.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/coare30_flux_cnrm.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/coare_cp.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/coare_cp.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/coare_cp.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/coare_cp.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/concvl.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/concvl.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/concvl.F90	(revision 4727)
@@ -3,5 +3,5 @@
                   t, q, t_wake, q_wake, s_wake, u, v, tra, ntra, &
                   Ale, Alp, sig1, w01, &
-                  d_t, d_q, d_u, d_v, d_tra, &
+                  d_t, d_q, d_qcomp, d_u, d_v, d_tra, &
                   rain, snow, kbas, ktop, sigd, &
                   cbmf, plcl, plfc, wbeff, convoccur, &
@@ -16,5 +16,5 @@
                   dd_t, dd_q, lalim_conv, wght_th, &                 ! RomP
                   evap, ep, epmlmMm, eplaMm, &                       ! RomP
-                  wdtrainA, wdtrainS, wdtrainM, wght, qtc, sigt, &
+                  wdtrainA, wdtrainS, wdtrainM, wght, qtc, sigt, detrain, &
                   tau_cld_cv, coefw_cld_cv, &                           ! RomP+RL, AJ
 !RomP <<<
@@ -138,5 +138,5 @@
   REAL, DIMENSION(klon,klev),   INTENT(INOUT)   :: sig1, w01
 
-  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: d_t, d_q, d_u, d_v
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: d_t, d_q, d_qcomp, d_u, d_v
   REAL, DIMENSION(klon,klev, nbtr),INTENT(OUT)  :: d_tra
   REAL, DIMENSION(klon),        INTENT(OUT)     :: rain, snow
@@ -186,5 +186,5 @@
   REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: wght                       !RL
   REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: qtc
-  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: sigt
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: sigt, detrain
   REAL,                         INTENT(OUT)     :: tau_cld_cv, coefw_cld_cv
   REAL, DIMENSION(klon),        INTENT(OUT)     :: epmax_diag                ! epmax_cape
@@ -588,5 +588,5 @@
                     Ale, Alp, omega, &
                     em_sig1feed, em_sig2feed, em_wght, &
-                    iflag, d_t, d_q, d_u, d_v, d_tra, rain, kbas, ktop, &
+                    iflag, d_t, d_q, d_qcomp, d_u, d_v, d_tra, rain, kbas, ktop, &
                     cbmf, plcl, plfc, wbeff, sig1, w01, ptop2, sigd, &
                     Ma, mip, Vprecip, Vprecipi, upwd, dnwd, dnwdbis, qcondc, wd, &
@@ -599,5 +599,5 @@
                     da, phi, mp, phii, d1a, dam, sij, wght, &           ! RomP+RL
                     qta, clw, elij, evap, ep, epmlmMm, eplaMm, &        ! RomP+RL
-                    wdtrainA, wdtrainS, wdtrainM, qtc, sigt, &
+                    wdtrainA, wdtrainS, wdtrainM, qtc, sigt, detrain, &
                     tau_cld_cv, coefw_cld_cv, &                         ! RomP,AJ
 !AC!+!RomP+jyg
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_etat0_limit_unstruct_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_etat0_limit_unstruct_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_etat0_limit_unstruct_mod.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/create_etat0_limit_unstruct_mod.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_etat0_unstruct_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_etat0_unstruct_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_etat0_unstruct_mod.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/create_etat0_unstruct_mod.F90
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_limit_unstruct_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_limit_unstruct_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmdiso/create_limit_unstruct_mod.F90	(revision 4727)
@@ -0,0 +1,1 @@
+link ../phylmd/create_limit_unstruct_mod.F90
